/*
 * Author:      William Chia-Wei Cheng (bill.cheng@acm.org)
 *
 * Copyright (C) 1990-2011, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm2/home/cvs/bc-src/tgif/chat.e,v 1.6 2011/05/16 16:21:56 william Exp $
 */

#ifndef _CHAT_E_
#define _CHAT_E_

#include "tidget.h"

extern char	*cmdLineChatNickName;

#ifdef _INCLUDE_FROM_CHAT_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_CHAT_C_*/

extern void	RedrawChatWindow ARGS_DECL((void));
extern void	MoveResizeChatWindow ARGS_DECL((int x, int y, int w, int h));
extern void	ChatEventHandler ARGS_DECL((XEvent*, TidgetInfo*));
extern int	IsChatWindowEvent ARGS_DECL((XEvent*, TidgetInfo**));

extern int	GetInitialChatWindowHeight ARGS_DECL((void));
extern void	SetChatWindowGeom ARGS_DECL((void));
extern void	MapChatSubWindows ARGS_DECL((void));
extern int	CreateChatSubWindows ARGS_DECL((void));

extern void	ChatAppendChatLine ARGS_DECL((TextFormatInfo*, char *nick_name,
				char *encoding, char *buf));
extern void	ChatAddUser ARGS_DECL((char*));

extern int	InitChat ARGS_DECL((void));
extern void	CleanUpChat ARGS_DECL((void));

#ifdef _INCLUDE_FROM_CHAT_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_CHAT_C_*/

#endif /*_CHAT_E_*/
