/*
 * Author:      William Chia-Wei Cheng (bill.cheng@acm.org)
 *
 * Copyright (C) 1990-2011, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product or service) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm2/home/cvs/bc-src/tgif/z_intrf.e,v 1.7 2011/05/16 16:22:00 william Exp $
 */

#ifndef _Z_INTRF_E_
#define _Z_INTRF_E_

#ifdef _INCLUDE_FROM_Z_INTRF_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_Z_INTRF_C_*/

extern int	HasZlibSupport ARGS_DECL((void));
extern int	DeflateFile ARGS_DECL((char *fname, char *deflated_fname));
extern int	DoDeflate ARGS_DECL((FILE *in_fp, char *in_buf, int bytes_left,
				FILE *out_fp, int use_def_compression,
				int use_byte_stuffing, int *pn_rc));
extern int	DoInflate ARGS_DECL((char *in_buf, int bytes_left,
				FILE *out_fp, int use_byte_unstuffing,
				int *pn_rc));
extern void	ZlibError ARGS_DECL((int status, int deflate));

#ifdef _INCLUDE_FROM_Z_INTRF_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_Z_INTRF_C_*/

#endif /*_Z_INTRF_E_*/
